# Generated by sila2.code_generator; sila2.__version__: 0.12.2
# -----
# This class does not do anything useful at runtime. Its only purpose is to provide type annotations.
# Since sphinx does not support .pyi files (yet?), this is a .py file.
# -----

from __future__ import annotations

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from typing import Iterable, List, Optional

    from measurementcontroller_types import (
        LoadFeatureCallConfigurationDB_Responses,
        SetFeatureCallConfiguration_Responses,
        SetPollingInterval_Responses,
        StartMeasurement_Responses,
        StopMeasurement_Responses,
    )
    from sila2.client import ClientMetadataInstance, ClientObservableProperty, ClientUnobservableProperty

    from .measurementcontroller_types import UUID


class MeasurementControllerClient:
    """

    Allows to start and stop a measurement.

    """

    FeatureCallConfiguration: ClientUnobservableProperty[str]
    """
    Get current Feature Call Configuration (YAML string).
    """

    CurrentMeasurements: ClientObservableProperty[List[UUID]]
    """
    A List of Measurement Command Execution UUIDs that are currently running.
    """

    PollingInterval: ClientObservableProperty[float]
    """
    The polling interval for the Measurement Controller in seconds.
    """

    def StartMeasurement(
        self, Name: str, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> StartMeasurement_Responses:
        """

        Starting an experiment

        """
        ...

    def StopMeasurement(
        self, CommandExecutionUUID: UUID, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> StopMeasurement_Responses:
        """
        Stop the current Measurement
        """
        ...

    def SetPollingInterval(
        self, Interval: float, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> SetPollingInterval_Responses:
        """
        Set the polling interval for the Measurement Controller in seconds.
        """
        ...

    def LoadFeatureCallConfigurationDB(
        self,
        LARADatabaseConnector: str,
        Namespace: str,
        FeatureCallConfigurationName: str,
        *,
        metadata: Optional[Iterable[ClientMetadataInstance]] = None,
    ) -> LoadFeatureCallConfigurationDB_Responses:
        """
        Load a Feature Call Configuration that describes what SiLA servers to call with which commads from the LARA Database in YAML format as defined in the sila_feature_call_model.yaml LinkML data model.
        """
        ...

    def SetFeatureCallConfiguration(
        self, FeatureCallConfiguration: str, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> SetFeatureCallConfiguration_Responses:
        """
        Set a new Feature Call Configuration that describes what SiLA servers to call with which commads. The configuration should be provided as a string in YAML format as defined in the sila_feature_call_model.yaml LinkML data model.
        """
        ...
